/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Enables or disables a capability on the virtual machine or virtual machine
 * scale set.
 *
 */
class AdditionalCapabilities {
  /**
   * Create a AdditionalCapabilities.
   * @member {boolean} [ultraSSDEnabled] The flag that enables or disables a
   * capability to have one or more managed data disks with UltraSSD_LRS
   * storage account type on the VM or VMSS. Managed disks with storage account
   * type UltraSSD_LRS can be added to a virtual machine or virtual machine
   * scale set only if this property is enabled.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AdditionalCapabilities
   *
   * @returns {object} metadata of AdditionalCapabilities
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdditionalCapabilities',
      type: {
        name: 'Composite',
        className: 'AdditionalCapabilities',
        modelProperties: {
          ultraSSDEnabled: {
            required: false,
            serializedName: 'ultraSSDEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AdditionalCapabilities;
