/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies additional XML formatted information that can be included in the
 * Unattend.xml file, which is used by Windows Setup. Contents are defined by
 * setting name, component name, and the pass in which the content is applied.
 *
 */
class AdditionalUnattendContent {
  /**
   * Create a AdditionalUnattendContent.
   * @member {string} [passName] The pass name. Currently, the only allowable
   * value is OobeSystem. Possible values include: 'OobeSystem'
   * @member {string} [componentName] The component name. Currently, the only
   * allowable value is Microsoft-Windows-Shell-Setup. Possible values include:
   * 'Microsoft-Windows-Shell-Setup'
   * @member {string} [settingName] Specifies the name of the setting to which
   * the content applies. Possible values are: FirstLogonCommands and
   * AutoLogon. Possible values include: 'AutoLogon', 'FirstLogonCommands'
   * @member {string} [content] Specifies the XML formatted content that is
   * added to the unattend.xml file for the specified path and component. The
   * XML must be less than 4KB and must include the root element for the
   * setting or feature that is being inserted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AdditionalUnattendContent
   *
   * @returns {object} metadata of AdditionalUnattendContent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdditionalUnattendContent',
      type: {
        name: 'Composite',
        className: 'AdditionalUnattendContent',
        modelProperties: {
          passName: {
            required: false,
            serializedName: 'passName',
            type: {
              name: 'Enum',
              allowedValues: [ 'OobeSystem' ]
            }
          },
          componentName: {
            required: false,
            serializedName: 'componentName',
            type: {
              name: 'Enum',
              allowedValues: [ 'Microsoft-Windows-Shell-Setup' ]
            }
          },
          settingName: {
            required: false,
            serializedName: 'settingName',
            type: {
              name: 'Enum',
              allowedValues: [ 'AutoLogon', 'FirstLogonCommands' ]
            }
          },
          content: {
            required: false,
            serializedName: 'content',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AdditionalUnattendContent;
