/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Api error.
 *
 */
class ApiError {
  /**
   * Create a ApiError.
   * @member {array} [details] The Api error details
   * @member {object} [innererror] The Api inner error
   * @member {string} [innererror.exceptiontype] The exception type.
   * @member {string} [innererror.errordetail] The internal error message or
   * exception dump.
   * @member {string} [code] The error code.
   * @member {string} [target] The target of the particular error.
   * @member {string} [message] The error message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiError
   *
   * @returns {object} metadata of ApiError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiError',
      type: {
        name: 'Composite',
        className: 'ApiError',
        modelProperties: {
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ApiErrorBaseElementType',
                  type: {
                    name: 'Composite',
                    className: 'ApiErrorBase'
                  }
              }
            }
          },
          innererror: {
            required: false,
            serializedName: 'innererror',
            type: {
              name: 'Composite',
              className: 'InnerError'
            }
          },
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiError;
