/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The configuration parameters used for performing automatic OS upgrade.
 *
 */
class AutomaticOSUpgradePolicy {
  /**
   * Create a AutomaticOSUpgradePolicy.
   * @member {boolean} [enableAutomaticOSUpgrade] Whether OS upgrades should
   * automatically be applied to scale set instances in a rolling fashion when
   * a newer version of the image becomes available. Default value is false.
   * @member {boolean} [disableAutomaticRollback] Whether OS image rollback
   * feature should be disabled. Default value is false.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutomaticOSUpgradePolicy
   *
   * @returns {object} metadata of AutomaticOSUpgradePolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutomaticOSUpgradePolicy',
      type: {
        name: 'Composite',
        className: 'AutomaticOSUpgradePolicy',
        modelProperties: {
          enableAutomaticOSUpgrade: {
            required: false,
            serializedName: 'enableAutomaticOSUpgrade',
            type: {
              name: 'Boolean'
            }
          },
          disableAutomaticRollback: {
            required: false,
            serializedName: 'disableAutomaticRollback',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AutomaticOSUpgradePolicy;
