/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Boot Diagnostics is a debugging feature which allows you to view Console
 * Output and Screenshot to diagnose VM status. <br><br> You can easily view
 * the output of your console log. <br><br> Azure also enables you to see a
 * screenshot of the VM from the hypervisor.
 *
 */
class BootDiagnostics {
  /**
   * Create a BootDiagnostics.
   * @member {boolean} [enabled] Whether boot diagnostics should be enabled on
   * the Virtual Machine.
   * @member {string} [storageUri] Uri of the storage account to use for
   * placing the console output and screenshot.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BootDiagnostics
   *
   * @returns {object} metadata of BootDiagnostics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BootDiagnostics',
      type: {
        name: 'Composite',
        className: 'BootDiagnostics',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          storageUri: {
            required: false,
            serializedName: 'storageUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BootDiagnostics;
