/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ContainerServiceDiagnosticsProfile.
 */
class ContainerServiceDiagnosticsProfile {
  /**
   * Create a ContainerServiceDiagnosticsProfile.
   * @member {object} vmDiagnostics Profile for the container service VM
   * diagnostic agent.
   * @member {boolean} [vmDiagnostics.enabled] Whether the VM diagnostic agent
   * is provisioned on the VM.
   * @member {string} [vmDiagnostics.storageUri] The URI of the storage account
   * where diagnostics are stored.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerServiceDiagnosticsProfile
   *
   * @returns {object} metadata of ContainerServiceDiagnosticsProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerServiceDiagnosticsProfile',
      type: {
        name: 'Composite',
        className: 'ContainerServiceDiagnosticsProfile',
        modelProperties: {
          vmDiagnostics: {
            required: true,
            serializedName: 'vmDiagnostics',
            type: {
              name: 'Composite',
              className: 'ContainerServiceVMDiagnostics'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerServiceDiagnosticsProfile;
