/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a service principal identity for the cluster to use for
 * manipulating Azure APIs.
 *
 */
class ContainerServiceServicePrincipalProfile {
  /**
   * Create a ContainerServiceServicePrincipalProfile.
   * @member {string} clientId The ID for the service principal.
   * @member {string} secret The secret password associated with the service
   * principal.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerServiceServicePrincipalProfile
   *
   * @returns {object} metadata of ContainerServiceServicePrincipalProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerServiceServicePrincipalProfile',
      type: {
        name: 'Composite',
        className: 'ContainerServiceServicePrincipalProfile',
        modelProperties: {
          clientId: {
            required: true,
            serializedName: 'clientId',
            type: {
              name: 'String'
            }
          },
          secret: {
            required: true,
            serializedName: 'secret',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerServiceServicePrincipalProfile;
