/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains information about SSH certificate public key data.
 *
 */
class ContainerServiceSshPublicKey {
  /**
   * Create a ContainerServiceSshPublicKey.
   * @member {string} keyData Certificate public key used to authenticate with
   * VMs through SSH. The certificate must be in PEM format with or without
   * headers.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerServiceSshPublicKey
   *
   * @returns {object} metadata of ContainerServiceSshPublicKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerServiceSshPublicKey',
      type: {
        name: 'Composite',
        className: 'ContainerServiceSshPublicKey',
        modelProperties: {
          keyData: {
            required: true,
            serializedName: 'keyData',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerServiceSshPublicKey;
