/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Profile for diagnostics on the container service VMs.
 *
 */
class ContainerServiceVMDiagnostics {
  /**
   * Create a ContainerServiceVMDiagnostics.
   * @member {boolean} enabled Whether the VM diagnostic agent is provisioned
   * on the VM.
   * @member {string} [storageUri] The URI of the storage account where
   * diagnostics are stored.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerServiceVMDiagnostics
   *
   * @returns {object} metadata of ContainerServiceVMDiagnostics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerServiceVMDiagnostics',
      type: {
        name: 'Composite',
        className: 'ContainerServiceVMDiagnostics',
        modelProperties: {
          enabled: {
            required: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          storageUri: {
            required: false,
            readOnly: true,
            serializedName: 'storageUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerServiceVMDiagnostics;
