/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the parameters of differencing disk settings that can be be
 * specified for operating system disk. <br><br> NOTE: The differencing disk
 * settings can only be specified for managed disk.
 *
 */
class DiffDiskSettings {
  /**
   * Create a DiffDiskSettings.
   * @member {string} [option] Specifies the differencing disk settings for
   * operating system disk. Possible values include: 'Local'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiffDiskSettings
   *
   * @returns {object} metadata of DiffDiskSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiffDiskSettings',
      type: {
        name: 'Composite',
        className: 'DiffDiskSettings',
        modelProperties: {
          option: {
            required: false,
            serializedName: 'option',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiffDiskSettings;
