/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The instance view of the disk.
 *
 */
class DiskInstanceView {
  /**
   * Create a DiskInstanceView.
   * @member {string} [name] The disk name.
   * @member {array} [encryptionSettings] Specifies the encryption settings for
   * the OS Disk. <br><br> Minimum api-version: 2015-06-15
   * @member {array} [statuses] The resource status information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiskInstanceView
   *
   * @returns {object} metadata of DiskInstanceView
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiskInstanceView',
      type: {
        name: 'Composite',
        className: 'DiskInstanceView',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          encryptionSettings: {
            required: false,
            serializedName: 'encryptionSettings',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DiskEncryptionSettingsElementType',
                  type: {
                    name: 'Composite',
                    className: 'DiskEncryptionSettings'
                  }
              }
            }
          },
          statuses: {
            required: false,
            serializedName: 'statuses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InstanceViewStatusElementType',
                  type: {
                    name: 'Composite',
                    className: 'InstanceViewStatus'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DiskInstanceView;
