/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The disks sku name. Can be Standard_LRS, Premium_LRS, StandardSSD_LRS, or
 * UltraSSD_LRS.
 *
 */
class DiskSku {
  /**
   * Create a DiskSku.
   * @member {string} [name] The sku name. Possible values include:
   * 'Standard_LRS', 'Premium_LRS', 'StandardSSD_LRS', 'UltraSSD_LRS'
   * @member {string} [tier] The sku tier. Default value: 'Standard' .
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiskSku
   *
   * @returns {object} metadata of DiskSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiskSku',
      type: {
        name: 'Composite',
        className: 'DiskSku',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            readOnly: true,
            serializedName: 'tier',
            defaultValue: 'Standard',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiskSku;
