/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Encryption settings for disk or snapshot
 *
 */
class EncryptionSettings {
  /**
   * Create a EncryptionSettings.
   * @member {boolean} [enabled] Set this flag to true and provide
   * DiskEncryptionKey and optional KeyEncryptionKey to enable encryption. Set
   * this flag to false and remove DiskEncryptionKey and KeyEncryptionKey to
   * disable encryption. If EncryptionSettings is null in the request object,
   * the existing settings remain unchanged.
   * @member {object} [diskEncryptionKey] Key Vault Secret Url and vault id of
   * the disk encryption key
   * @member {object} [diskEncryptionKey.sourceVault] Resource id of the
   * KeyVault containing the key or secret
   * @member {string} [diskEncryptionKey.sourceVault.id] Resource Id
   * @member {string} [diskEncryptionKey.secretUrl] Url pointing to a key or
   * secret in KeyVault
   * @member {object} [keyEncryptionKey] Key Vault Key Url and vault id of the
   * key encryption key
   * @member {object} [keyEncryptionKey.sourceVault] Resource id of the
   * KeyVault containing the key or secret
   * @member {string} [keyEncryptionKey.sourceVault.id] Resource Id
   * @member {string} [keyEncryptionKey.keyUrl] Url pointing to a key or secret
   * in KeyVault
   */
  constructor() {
  }

  /**
   * Defines the metadata of EncryptionSettings
   *
   * @returns {object} metadata of EncryptionSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EncryptionSettings',
      type: {
        name: 'Composite',
        className: 'EncryptionSettings',
        modelProperties: {
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          },
          diskEncryptionKey: {
            required: false,
            serializedName: 'diskEncryptionKey',
            type: {
              name: 'Composite',
              className: 'KeyVaultAndSecretReference'
            }
          },
          keyEncryptionKey: {
            required: false,
            serializedName: 'keyEncryptionKey',
            type: {
              name: 'Composite',
              className: 'KeyVaultAndKeyReference'
            }
          }
        }
      }
    };
  }
}

module.exports = EncryptionSettings;
