/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Specifies information about the Shared Image Gallery that you want to create
 * or update.
 *
 * @extends models['Resource']
 */
class Gallery extends models['Resource'] {
  /**
   * Create a Gallery.
   * @member {string} [description] The description of this Shared Image
   * Gallery resource. This property is updateable.
   * @member {object} [identifier]
   * @member {string} [identifier.uniqueName] The unique name of the Shared
   * Image Gallery. This name is generated automatically by Azure.
   * @member {string} [provisioningState] The current state of the gallery. The
   * provisioning state, which only appears in the response. Possible values
   * include: 'Creating', 'Updating', 'Failed', 'Succeeded', 'Deleting',
   * 'Migrating'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Gallery
   *
   * @returns {object} metadata of Gallery
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Gallery',
      type: {
        name: 'Composite',
        className: 'Gallery',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          identifier: {
            required: false,
            serializedName: 'properties.identifier',
            type: {
              name: 'Composite',
              className: 'GalleryIdentifier'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Gallery;
