/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the basic gallery artifact publishing profile.
 *
 */
class GalleryArtifactPublishingProfileBase {
  /**
   * Create a GalleryArtifactPublishingProfileBase.
   * @member {array} [targetRegions] The target regions where the Image Version
   * is going to be replicated to. This property is updateable.
   * @member {object} source
   * @member {object} [source.managedImage]
   * @member {string} [source.managedImage.id] The managed artifact id.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GalleryArtifactPublishingProfileBase
   *
   * @returns {object} metadata of GalleryArtifactPublishingProfileBase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryArtifactPublishingProfileBase',
      type: {
        name: 'Composite',
        className: 'GalleryArtifactPublishingProfileBase',
        modelProperties: {
          targetRegions: {
            required: false,
            serializedName: 'targetRegions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TargetRegionElementType',
                  type: {
                    name: 'Composite',
                    className: 'TargetRegion'
                  }
              }
            }
          },
          source: {
            required: true,
            serializedName: 'source',
            type: {
              name: 'Composite',
              className: 'GalleryArtifactSource'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryArtifactPublishingProfileBase;
