/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This is the data disk image.
 *
 * @extends models['GalleryDiskImage']
 */
class GalleryDataDiskImage extends models['GalleryDiskImage'] {
  /**
   * Create a GalleryDataDiskImage.
   * @member {number} [lun] This property specifies the logical unit number of
   * the data disk. This value is used to identify data disks within the
   * Virtual Machine and therefore must be unique for each data disk attached
   * to the Virtual Machine.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GalleryDataDiskImage
   *
   * @returns {object} metadata of GalleryDataDiskImage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryDataDiskImage',
      type: {
        name: 'Composite',
        className: 'GalleryDataDiskImage',
        modelProperties: {
          sizeInGB: {
            required: false,
            readOnly: true,
            serializedName: 'sizeInGB',
            type: {
              name: 'Number'
            }
          },
          hostCaching: {
            required: false,
            readOnly: true,
            serializedName: 'hostCaching',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'ReadOnly', 'ReadWrite' ]
            }
          },
          lun: {
            required: false,
            readOnly: true,
            serializedName: 'lun',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryDataDiskImage;
