/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This is the gallery Image Definition identifier.
 *
 */
class GalleryImageIdentifier {
  /**
   * Create a GalleryImageIdentifier.
   * @member {string} publisher The name of the gallery Image Definition
   * publisher.
   * @member {string} offer The name of the gallery Image Definition offer.
   * @member {string} sku The name of the gallery Image Definition SKU.
   */
  constructor() {
  }

  /**
   * Defines the metadata of GalleryImageIdentifier
   *
   * @returns {object} metadata of GalleryImageIdentifier
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryImageIdentifier',
      type: {
        name: 'Composite',
        className: 'GalleryImageIdentifier',
        modelProperties: {
          publisher: {
            required: true,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          offer: {
            required: true,
            serializedName: 'offer',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: true,
            serializedName: 'sku',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryImageIdentifier;
