/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The List Gallery Images operation response.
 */
class GalleryImageList extends Array {
  /**
   * Create a GalleryImageList.
   * @member {string} [nextLink] The uri to fetch the next page of Image
   * Definitions in the Shared Image Gallery. Call ListNext() with this to
   * fetch the next page of gallery Image Definitions.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GalleryImageList
   *
   * @returns {object} metadata of GalleryImageList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryImageList',
      type: {
        name: 'Composite',
        className: 'GalleryImageList',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'GalleryImageElementType',
                  type: {
                    name: 'Composite',
                    className: 'GalleryImage'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryImageList;
