/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The publishing profile of a gallery Image Version.
 *
 * @extends models['GalleryArtifactPublishingProfileBase']
 */
class GalleryImageVersionPublishingProfile extends models['GalleryArtifactPublishingProfileBase'] {
  /**
   * Create a GalleryImageVersionPublishingProfile.
   * @member {number} [replicaCount] The number of replicas of the Image
   * Version to be created per region. This property would take effect for a
   * region when regionalReplicaCount is not specified. This property is
   * updateable.
   * @member {boolean} [excludeFromLatest] If set to true, Virtual Machines
   * deployed from the latest version of the Image Definition won't use this
   * Image Version.
   * @member {date} [publishedDate] The timestamp for when the gallery Image
   * Version is published.
   * @member {date} [endOfLifeDate] The end of life date of the gallery Image
   * Version. This property can be used for decommissioning purposes. This
   * property is updateable.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GalleryImageVersionPublishingProfile
   *
   * @returns {object} metadata of GalleryImageVersionPublishingProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryImageVersionPublishingProfile',
      type: {
        name: 'Composite',
        className: 'GalleryImageVersionPublishingProfile',
        modelProperties: {
          targetRegions: {
            required: false,
            serializedName: 'targetRegions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TargetRegionElementType',
                  type: {
                    name: 'Composite',
                    className: 'TargetRegion'
                  }
              }
            }
          },
          source: {
            required: true,
            serializedName: 'source',
            type: {
              name: 'Composite',
              className: 'GalleryArtifactSource'
            }
          },
          replicaCount: {
            required: false,
            serializedName: 'replicaCount',
            type: {
              name: 'Number'
            }
          },
          excludeFromLatest: {
            required: false,
            serializedName: 'excludeFromLatest',
            type: {
              name: 'Boolean'
            }
          },
          publishedDate: {
            required: false,
            readOnly: true,
            serializedName: 'publishedDate',
            type: {
              name: 'DateTime'
            }
          },
          endOfLifeDate: {
            required: false,
            serializedName: 'endOfLifeDate',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryImageVersionPublishingProfile;
