/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This is the OS disk image.
 *
 * @extends models['GalleryDiskImage']
 */
class GalleryOSDiskImage extends models['GalleryDiskImage'] {
  /**
   * Create a GalleryOSDiskImage.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of GalleryOSDiskImage
   *
   * @returns {object} metadata of GalleryOSDiskImage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GalleryOSDiskImage',
      type: {
        name: 'Composite',
        className: 'GalleryOSDiskImage',
        modelProperties: {
          sizeInGB: {
            required: false,
            readOnly: true,
            serializedName: 'sizeInGB',
            type: {
              name: 'Number'
            }
          },
          hostCaching: {
            required: false,
            readOnly: true,
            serializedName: 'hostCaching',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'ReadOnly', 'ReadWrite' ]
            }
          }
        }
      }
    };
  }
}

module.exports = GalleryOSDiskImage;
