/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The source image used for creating the disk.
 *
 */
class ImageDiskReference {
  /**
   * Create a ImageDiskReference.
   * @member {string} id A relative uri containing either a Platform Imgage
   * Repository or user image reference.
   * @member {number} [lun] If the disk is created from an image's data disk,
   * this is an index that indicates which of the data disks in the image to
   * use. For OS disks, this field is null.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageDiskReference
   *
   * @returns {object} metadata of ImageDiskReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageDiskReference',
      type: {
        name: 'Composite',
        className: 'ImageDiskReference',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          lun: {
            required: false,
            serializedName: 'lun',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageDiskReference;
