/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Specifies information about the image to use. You can specify information
 * about platform images, marketplace images, or virtual machine images. This
 * element is required when you want to use a platform image, marketplace
 * image, or virtual machine image, but is not used in other creation
 * operations.
 *
 * @extends models['SubResource']
 */
class ImageReference extends models['SubResource'] {
  /**
   * Create a ImageReference.
   * @member {string} [publisher] The image publisher.
   * @member {string} [offer] Specifies the offer of the platform image or
   * marketplace image used to create the virtual machine.
   * @member {string} [sku] The image SKU.
   * @member {string} [version] Specifies the version of the platform image or
   * marketplace image used to create the virtual machine. The allowed formats
   * are Major.Minor.Build or 'latest'. Major, Minor, and Build are decimal
   * numbers. Specify 'latest' to use the latest version of an image available
   * at deploy time. Even if you use 'latest', the VM image will not
   * automatically update after deploy time even if a new version becomes
   * available.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ImageReference
   *
   * @returns {object} metadata of ImageReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageReference',
      type: {
        name: 'Composite',
        className: 'ImageReference',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: false,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          offer: {
            required: false,
            serializedName: 'offer',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageReference;
