/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Key Vault Secret Url and vault id of the encryption key
 *
 */
class KeyVaultAndSecretReference {
  /**
   * Create a KeyVaultAndSecretReference.
   * @member {object} sourceVault Resource id of the KeyVault containing the
   * key or secret
   * @member {string} [sourceVault.id] Resource Id
   * @member {string} secretUrl Url pointing to a key or secret in KeyVault
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultAndSecretReference
   *
   * @returns {object} metadata of KeyVaultAndSecretReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultAndSecretReference',
      type: {
        name: 'Composite',
        className: 'KeyVaultAndSecretReference',
        modelProperties: {
          sourceVault: {
            required: true,
            serializedName: 'sourceVault',
            type: {
              name: 'Composite',
              className: 'SourceVault'
            }
          },
          secretUrl: {
            required: true,
            serializedName: 'secretUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultAndSecretReference;
