/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a reference to Key Vault Key
 *
 */
class KeyVaultKeyReference {
  /**
   * Create a KeyVaultKeyReference.
   * @member {string} keyUrl The URL referencing a key encryption key in Key
   * Vault.
   * @member {object} sourceVault The relative URL of the Key Vault containing
   * the key.
   * @member {string} [sourceVault.id] Resource Id
   */
  constructor() {
  }

  /**
   * Defines the metadata of KeyVaultKeyReference
   *
   * @returns {object} metadata of KeyVaultKeyReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KeyVaultKeyReference',
      type: {
        name: 'Composite',
        className: 'KeyVaultKeyReference',
        modelProperties: {
          keyUrl: {
            required: true,
            serializedName: 'keyUrl',
            type: {
              name: 'String'
            }
          },
          sourceVault: {
            required: true,
            serializedName: 'sourceVault',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          }
        }
      }
    };
  }
}

module.exports = KeyVaultKeyReference;
