/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The List Usages operation response.
 */
class ListUsagesResult extends Array {
  /**
   * Create a ListUsagesResult.
   * @member {string} [nextLink] The URI to fetch the next page of compute
   * resource usage information. Call ListNext() with this to fetch the next
   * page of compute resource usage information.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ListUsagesResult
   *
   * @returns {object} metadata of ListUsagesResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListUsagesResult',
      type: {
        name: 'Composite',
        className: 'ListUsagesResult',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UsageElementType',
                  type: {
                    name: 'Composite',
                    className: 'Usage'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ListUsagesResult;
