/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Api input base class for LogAnalytics Api.
 *
 */
class LogAnalyticsInputBase {
  /**
   * Create a LogAnalyticsInputBase.
   * @member {string} blobContainerSasUri SAS Uri of the logging blob container
   * to which LogAnalytics Api writes output logs to.
   * @member {date} fromTime From time of the query
   * @member {date} toTime To time of the query
   * @member {boolean} [groupByThrottlePolicy] Group query result by Throttle
   * Policy applied.
   * @member {boolean} [groupByOperationName] Group query result by  by
   * Operation Name.
   * @member {boolean} [groupByResourceName] Group query result by Resource
   * Name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LogAnalyticsInputBase
   *
   * @returns {object} metadata of LogAnalyticsInputBase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogAnalyticsInputBase',
      type: {
        name: 'Composite',
        className: 'LogAnalyticsInputBase',
        modelProperties: {
          blobContainerSasUri: {
            required: true,
            serializedName: 'blobContainerSasUri',
            type: {
              name: 'String'
            }
          },
          fromTime: {
            required: true,
            serializedName: 'fromTime',
            type: {
              name: 'DateTime'
            }
          },
          toTime: {
            required: true,
            serializedName: 'toTime',
            type: {
              name: 'DateTime'
            }
          },
          groupByThrottlePolicy: {
            required: false,
            serializedName: 'groupByThrottlePolicy',
            type: {
              name: 'Boolean'
            }
          },
          groupByOperationName: {
            required: false,
            serializedName: 'groupByOperationName',
            type: {
              name: 'Boolean'
            }
          },
          groupByResourceName: {
            required: false,
            serializedName: 'groupByResourceName',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = LogAnalyticsInputBase;
