/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters of a managed disk.
 *
 * @extends models['SubResource']
 */
class ManagedDiskParameters extends models['SubResource'] {
  /**
   * Create a ManagedDiskParameters.
   * @member {string} [storageAccountType] Specifies the storage account type
   * for the managed disk. NOTE: UltraSSD_LRS can only be used with data disks,
   * it cannot be used with OS Disk. Possible values include: 'Standard_LRS',
   * 'Premium_LRS', 'StandardSSD_LRS', 'UltraSSD_LRS'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ManagedDiskParameters
   *
   * @returns {object} metadata of ManagedDiskParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedDiskParameters',
      type: {
        name: 'Composite',
        className: 'ManagedDiskParameters',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          storageAccountType: {
            required: false,
            serializedName: 'storageAccountType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedDiskParameters;
