/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Operation status response
 *
 */
class OperationStatusResponse {
  /**
   * Create a OperationStatusResponse.
   * @member {string} [name] Operation ID
   * @member {string} [status] Operation status
   * @member {date} [startTime] Start time of the operation
   * @member {date} [endTime] End time of the operation
   * @member {object} [error] Api error
   * @member {array} [error.details] The Api error details
   * @member {object} [error.innererror] The Api inner error
   * @member {string} [error.innererror.exceptiontype] The exception type.
   * @member {string} [error.innererror.errordetail] The internal error message
   * or exception dump.
   * @member {string} [error.code] The error code.
   * @member {string} [error.target] The target of the particular error.
   * @member {string} [error.message] The error message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationStatusResponse
   *
   * @returns {object} metadata of OperationStatusResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationStatusResponse',
      type: {
        name: 'Composite',
        className: 'OperationStatusResponse',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            readOnly: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            readOnly: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          error: {
            required: false,
            readOnly: true,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ApiError'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationStatusResponse;
