/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies information about the marketplace image used to create the virtual
 * machine. This element is only used for marketplace images. Before you can
 * use a marketplace image from an API, you must enable the image for
 * programmatic use.  In the Azure portal, find the marketplace image that you
 * want to use and then click **Want to deploy programmatically, Get Started
 * ->**. Enter any required information and then click **Save**.
 *
 */
class Plan {
  /**
   * Create a Plan.
   * @member {string} [name] The plan ID.
   * @member {string} [publisher] The publisher ID.
   * @member {string} [product] Specifies the product of the image from the
   * marketplace. This is the same value as Offer under the imageReference
   * element.
   * @member {string} [promotionCode] The promotion code.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Plan
   *
   * @returns {object} metadata of Plan
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Plan',
      type: {
        name: 'Composite',
        className: 'Plan',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: false,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          product: {
            required: false,
            serializedName: 'product',
            type: {
              name: 'String'
            }
          },
          promotionCode: {
            required: false,
            serializedName: 'promotionCode',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Plan;
