/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Used for establishing the purchase context of any 3rd Party artifact through
 * MarketPlace.
 *
 */
class PurchasePlan {
  /**
   * Create a PurchasePlan.
   * @member {string} publisher The publisher ID.
   * @member {string} name The plan ID.
   * @member {string} product Specifies the product of the image from the
   * marketplace. This is the same value as Offer under the imageReference
   * element.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PurchasePlan
   *
   * @returns {object} metadata of PurchasePlan
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PurchasePlan',
      type: {
        name: 'Composite',
        className: 'PurchasePlan',
        modelProperties: {
          publisher: {
            required: true,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          product: {
            required: true,
            serializedName: 'product',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PurchasePlan;
