/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties describe the recommended machine configuration for this Image
 * Definition. These properties are updateable.
 *
 */
class RecommendedMachineConfiguration {
  /**
   * Create a RecommendedMachineConfiguration.
   * @member {object} [vCPUs]
   * @member {number} [vCPUs.min] The minimum number of the resource.
   * @member {number} [vCPUs.max] The maximum number of the resource.
   * @member {object} [memory]
   * @member {number} [memory.min] The minimum number of the resource.
   * @member {number} [memory.max] The maximum number of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RecommendedMachineConfiguration
   *
   * @returns {object} metadata of RecommendedMachineConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RecommendedMachineConfiguration',
      type: {
        name: 'Composite',
        className: 'RecommendedMachineConfiguration',
        modelProperties: {
          vCPUs: {
            required: false,
            serializedName: 'vCPUs',
            type: {
              name: 'Composite',
              className: 'ResourceRange'
            }
          },
          memory: {
            required: false,
            serializedName: 'memory',
            type: {
              name: 'Composite',
              className: 'ResourceRange'
            }
          }
        }
      }
    };
  }
}

module.exports = RecommendedMachineConfiguration;
