/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This is the regional replication status.
 *
 */
class RegionalReplicationStatus {
  /**
   * Create a RegionalReplicationStatus.
   * @member {string} [region] The region to which the gallery Image Version is
   * being replicated to.
   * @member {string} [state] This is the regional replication state. Possible
   * values include: 'Unknown', 'Replicating', 'Completed', 'Failed'
   * @member {string} [details] The details of the replication status.
   * @member {number} [progress] It indicates progress of the replication job.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RegionalReplicationStatus
   *
   * @returns {object} metadata of RegionalReplicationStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegionalReplicationStatus',
      type: {
        name: 'Composite',
        className: 'RegionalReplicationStatus',
        modelProperties: {
          region: {
            required: false,
            readOnly: true,
            serializedName: 'region',
            type: {
              name: 'String'
            }
          },
          state: {
            required: false,
            readOnly: true,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            readOnly: true,
            serializedName: 'details',
            type: {
              name: 'String'
            }
          },
          progress: {
            required: false,
            readOnly: true,
            serializedName: 'progress',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RegionalReplicationStatus;
