/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This is the replication status of the gallery Image Version.
 *
 */
class ReplicationStatus {
  /**
   * Create a ReplicationStatus.
   * @member {string} [aggregatedState] This is the aggregated replication
   * status based on all the regional replication status flags. Possible values
   * include: 'Unknown', 'InProgress', 'Completed', 'Failed'
   * @member {array} [summary] This is a summary of replication status for each
   * region.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReplicationStatus
   *
   * @returns {object} metadata of ReplicationStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReplicationStatus',
      type: {
        name: 'Composite',
        className: 'ReplicationStatus',
        modelProperties: {
          aggregatedState: {
            required: false,
            readOnly: true,
            serializedName: 'aggregatedState',
            type: {
              name: 'String'
            }
          },
          summary: {
            required: false,
            readOnly: true,
            serializedName: 'summary',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RegionalReplicationStatusElementType',
                  type: {
                    name: 'Composite',
                    className: 'RegionalReplicationStatus'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ReplicationStatus;
