/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Api request input for LogAnalytics getRequestRateByInterval Api.
 *
 * @extends models['LogAnalyticsInputBase']
 */
class RequestRateByIntervalInput extends models['LogAnalyticsInputBase'] {
  /**
   * Create a RequestRateByIntervalInput.
   * @member {string} intervalLength Interval value in minutes used to create
   * LogAnalytics call rate logs. Possible values include: 'ThreeMins',
   * 'FiveMins', 'ThirtyMins', 'SixtyMins'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RequestRateByIntervalInput
   *
   * @returns {object} metadata of RequestRateByIntervalInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RequestRateByIntervalInput',
      type: {
        name: 'Composite',
        className: 'RequestRateByIntervalInput',
        modelProperties: {
          blobContainerSasUri: {
            required: true,
            serializedName: 'blobContainerSasUri',
            type: {
              name: 'String'
            }
          },
          fromTime: {
            required: true,
            serializedName: 'fromTime',
            type: {
              name: 'DateTime'
            }
          },
          toTime: {
            required: true,
            serializedName: 'toTime',
            type: {
              name: 'DateTime'
            }
          },
          groupByThrottlePolicy: {
            required: false,
            serializedName: 'groupByThrottlePolicy',
            type: {
              name: 'Boolean'
            }
          },
          groupByOperationName: {
            required: false,
            serializedName: 'groupByOperationName',
            type: {
              name: 'Boolean'
            }
          },
          groupByResourceName: {
            required: false,
            serializedName: 'groupByResourceName',
            type: {
              name: 'Boolean'
            }
          },
          intervalLength: {
            required: true,
            serializedName: 'intervalLength',
            type: {
              name: 'Enum',
              allowedValues: [ 'ThreeMins', 'FiveMins', 'ThirtyMins', 'SixtyMins' ]
            }
          }
        }
      }
    };
  }
}

module.exports = RequestRateByIntervalInput;
