/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes metadata for retrieving price info.
 *
 */
class ResourceSkuCosts {
  /**
   * Create a ResourceSkuCosts.
   * @member {string} [meterID] Used for querying price from commerce.
   * @member {number} [quantity] The multiplier is needed to extend the base
   * metered cost.
   * @member {string} [extendedUnit] An invariant to show the extended unit.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSkuCosts
   *
   * @returns {object} metadata of ResourceSkuCosts
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSkuCosts',
      type: {
        name: 'Composite',
        className: 'ResourceSkuCosts',
        modelProperties: {
          meterID: {
            required: false,
            readOnly: true,
            serializedName: 'meterID',
            type: {
              name: 'String'
            }
          },
          quantity: {
            required: false,
            readOnly: true,
            serializedName: 'quantity',
            type: {
              name: 'Number'
            }
          },
          extendedUnit: {
            required: false,
            readOnly: true,
            serializedName: 'extendedUnit',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSkuCosts;
