/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ResourceSkuLocationInfo.
 */
class ResourceSkuLocationInfo {
  /**
   * Create a ResourceSkuLocationInfo.
   * @member {string} [location] Location of the SKU
   * @member {array} [zones] List of availability zones where the SKU is
   * supported.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSkuLocationInfo
   *
   * @returns {object} metadata of ResourceSkuLocationInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSkuLocationInfo',
      type: {
        name: 'Composite',
        className: 'ResourceSkuLocationInfo',
        modelProperties: {
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          zones: {
            required: false,
            readOnly: true,
            serializedName: 'zones',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSkuLocationInfo;
