/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ResourceSkuRestrictionInfo.
 */
class ResourceSkuRestrictionInfo {
  /**
   * Create a ResourceSkuRestrictionInfo.
   * @member {array} [locations] Locations where the SKU is restricted
   * @member {array} [zones] List of availability zones where the SKU is
   * restricted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSkuRestrictionInfo
   *
   * @returns {object} metadata of ResourceSkuRestrictionInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSkuRestrictionInfo',
      type: {
        name: 'Composite',
        className: 'ResourceSkuRestrictionInfo',
        modelProperties: {
          locations: {
            required: false,
            readOnly: true,
            serializedName: 'locations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          zones: {
            required: false,
            readOnly: true,
            serializedName: 'zones',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSkuRestrictionInfo;
