/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes scaling information of a SKU.
 *
 */
class ResourceSkuRestrictions {
  /**
   * Create a ResourceSkuRestrictions.
   * @member {string} [type] The type of restrictions. Possible values include:
   * 'Location', 'Zone'
   * @member {array} [values] The value of restrictions. If the restriction
   * type is set to location. This would be different locations where the SKU
   * is restricted.
   * @member {object} [restrictionInfo] The information about the restriction
   * where the SKU cannot be used.
   * @member {array} [restrictionInfo.locations] Locations where the SKU is
   * restricted
   * @member {array} [restrictionInfo.zones] List of availability zones where
   * the SKU is restricted.
   * @member {string} [reasonCode] The reason for restriction. Possible values
   * include: 'QuotaId', 'NotAvailableForSubscription'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSkuRestrictions
   *
   * @returns {object} metadata of ResourceSkuRestrictions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSkuRestrictions',
      type: {
        name: 'Composite',
        className: 'ResourceSkuRestrictions',
        modelProperties: {
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'Location', 'Zone' ]
            }
          },
          values: {
            required: false,
            readOnly: true,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          restrictionInfo: {
            required: false,
            readOnly: true,
            serializedName: 'restrictionInfo',
            type: {
              name: 'Composite',
              className: 'ResourceSkuRestrictionInfo'
            }
          },
          reasonCode: {
            required: false,
            readOnly: true,
            serializedName: 'reasonCode',
            type: {
              name: 'Enum',
              allowedValues: [ 'QuotaId', 'NotAvailableForSubscription' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSkuRestrictions;
