/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Compute List Skus operation response.
 */
class ResourceSkusResult extends Array {
  /**
   * Create a ResourceSkusResult.
   * @member {string} [nextLink] The uri to fetch the next page of Compute
   * Skus. Call ListNext() with this to fetch the next page of VMSS Skus.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ResourceSkusResult
   *
   * @returns {object} metadata of ResourceSkusResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSkusResult',
      type: {
        name: 'Composite',
        className: 'ResourceSkusResult',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ResourceSkuElementType',
                  type: {
                    name: 'Composite',
                    className: 'ResourceSku'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSkusResult;
