/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Resource model definition.
 *
 */
class ResourceUpdate {
  /**
   * Create a ResourceUpdate.
   * @member {object} [tags] Resource tags
   * @member {object} [sku]
   * @member {string} [sku.name] The sku name. Possible values include:
   * 'Standard_LRS', 'Premium_LRS'
   * @member {string} [sku.tier] The sku tier.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceUpdate
   *
   * @returns {object} metadata of ResourceUpdate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceUpdate',
      type: {
        name: 'Composite',
        className: 'ResourceUpdate',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: false,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'DiskSku'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceUpdate;
