/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the properties of a Run Command metadata.
 *
 */
class RunCommandDocumentBase {
  /**
   * Create a RunCommandDocumentBase.
   * @member {string} schema The VM run command schema.
   * @member {string} id The VM run command id.
   * @member {string} osType The Operating System type. Possible values
   * include: 'Windows', 'Linux'
   * @member {string} label The VM run command label.
   * @member {string} description The VM run command description.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RunCommandDocumentBase
   *
   * @returns {object} metadata of RunCommandDocumentBase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RunCommandDocumentBase',
      type: {
        name: 'Composite',
        className: 'RunCommandDocumentBase',
        modelProperties: {
          schema: {
            required: true,
            serializedName: '$schema',
            type: {
              name: 'String'
            }
          },
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          osType: {
            required: true,
            serializedName: 'osType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Windows', 'Linux' ]
            }
          },
          label: {
            required: true,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          description: {
            required: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RunCommandDocumentBase;
