/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Capture Virtual Machine parameters.
 *
 */
class RunCommandInput {
  /**
   * Create a RunCommandInput.
   * @member {string} commandId The run command id.
   * @member {array} [script] Optional. The script to be executed.  When this
   * value is given, the given script will override the default script of the
   * command.
   * @member {array} [parameters] The run command parameters.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RunCommandInput
   *
   * @returns {object} metadata of RunCommandInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RunCommandInput',
      type: {
        name: 'Composite',
        className: 'RunCommandInput',
        modelProperties: {
          commandId: {
            required: true,
            serializedName: 'commandId',
            type: {
              name: 'String'
            }
          },
          script: {
            required: false,
            serializedName: 'script',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RunCommandInputParameterElementType',
                  type: {
                    name: 'Composite',
                    className: 'RunCommandInputParameter'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = RunCommandInput;
