/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a virtual machine scale set sku.
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} [name] The sku name.
   * @member {string} [tier] Specifies the tier of virtual machines in a scale
   * set.<br /><br /> Possible Values:<br /><br /> **Standard**<br /><br />
   * **Basic**
   * @member {number} [capacity] Specifies the number of virtual machines in
   * the scale set.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
