/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * SSH configuration for Linux based VMs running on Azure
 *
 */
class SshConfiguration {
  /**
   * Create a SshConfiguration.
   * @member {array} [publicKeys] The list of SSH public keys used to
   * authenticate with linux based VMs.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SshConfiguration
   *
   * @returns {object} metadata of SshConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SshConfiguration',
      type: {
        name: 'Composite',
        className: 'SshConfiguration',
        modelProperties: {
          publicKeys: {
            required: false,
            serializedName: 'publicKeys',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SshPublicKeyElementType',
                  type: {
                    name: 'Composite',
                    className: 'SshPublicKey'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SshConfiguration;
