/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains information about SSH certificate public key and the path on the
 * Linux VM where the public key is placed.
 *
 */
class SshPublicKey {
  /**
   * Create a SshPublicKey.
   * @member {string} [path] Specifies the full path on the created VM where
   * ssh public key is stored. If the file already exists, the specified key is
   * appended to the file. Example: /home/user/.ssh/authorized_keys
   * @member {string} [keyData] SSH public key certificate used to authenticate
   * with the VM through ssh. The key needs to be at least 2048-bit and in
   * ssh-rsa format. <br><br> For creating ssh keys, see [Create SSH keys on
   * Linux and Mac for Linux VMs in
   * Azure](https://docs.microsoft.com/azure/virtual-machines/virtual-machines-linux-mac-create-ssh-keys?toc=%2fazure%2fvirtual-machines%2flinux%2ftoc.json).
   */
  constructor() {
  }

  /**
   * Defines the metadata of SshPublicKey
   *
   * @returns {object} metadata of SshPublicKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SshPublicKey',
      type: {
        name: 'Composite',
        className: 'SshPublicKey',
        modelProperties: {
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          },
          keyData: {
            required: false,
            serializedName: 'keyData',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SshPublicKey;
