/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the target region information.
 *
 */
class TargetRegion {
  /**
   * Create a TargetRegion.
   * @member {string} name The name of the region.
   * @member {number} [regionalReplicaCount] The number of replicas of the
   * Image Version to be created per region. This property is updateable.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TargetRegion
   *
   * @returns {object} metadata of TargetRegion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TargetRegion',
      type: {
        name: 'Composite',
        className: 'TargetRegion',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          regionalReplicaCount: {
            required: false,
            serializedName: 'regionalReplicaCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = TargetRegion;
