/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Api request input for LogAnalytics getThrottledRequests Api.
 *
 * @extends models['LogAnalyticsInputBase']
 */
class ThrottledRequestsInput extends models['LogAnalyticsInputBase'] {
  /**
   * Create a ThrottledRequestsInput.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ThrottledRequestsInput
   *
   * @returns {object} metadata of ThrottledRequestsInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ThrottledRequestsInput',
      type: {
        name: 'Composite',
        className: 'ThrottledRequestsInput',
        modelProperties: {
          blobContainerSasUri: {
            required: true,
            serializedName: 'blobContainerSasUri',
            type: {
              name: 'String'
            }
          },
          fromTime: {
            required: true,
            serializedName: 'fromTime',
            type: {
              name: 'DateTime'
            }
          },
          toTime: {
            required: true,
            serializedName: 'toTime',
            type: {
              name: 'DateTime'
            }
          },
          groupByThrottlePolicy: {
            required: false,
            serializedName: 'groupByThrottlePolicy',
            type: {
              name: 'Boolean'
            }
          },
          groupByOperationName: {
            required: false,
            serializedName: 'groupByOperationName',
            type: {
              name: 'Boolean'
            }
          },
          groupByResourceName: {
            required: false,
            serializedName: 'groupByResourceName',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ThrottledRequestsInput;
