/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a single certificate reference in a Key Vault, and where the
 * certificate should reside on the VM.
 *
 */
class VaultCertificate {
  /**
   * Create a VaultCertificate.
   * @member {string} [certificateUrl] This is the URL of a certificate that
   * has been uploaded to Key Vault as a secret. For adding a secret to the Key
   * Vault, see [Add a key or secret to the key
   * vault](https://docs.microsoft.com/azure/key-vault/key-vault-get-started/#add).
   * In this case, your certificate needs to be It is the Base64 encoding of
   * the following JSON Object which is encoded in UTF-8: <br><br> {<br>
   * "data":"<Base64-encoded-certificate>",<br>  "dataType":"pfx",<br>
   * "password":"<pfx-file-password>"<br>}
   * @member {string} [certificateStore] For Windows VMs, specifies the
   * certificate store on the Virtual Machine to which the certificate should
   * be added. The specified certificate store is implicitly in the
   * LocalMachine account. <br><br>For Linux VMs, the certificate file is
   * placed under the /var/lib/waagent directory, with the file name
   * <UppercaseThumbprint>.crt for the X509 certificate file and
   * <UppercaseThumbpring>.prv for private key. Both of these files are .pem
   * formatted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VaultCertificate
   *
   * @returns {object} metadata of VaultCertificate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VaultCertificate',
      type: {
        name: 'Composite',
        className: 'VaultCertificate',
        modelProperties: {
          certificateUrl: {
            required: false,
            serializedName: 'certificateUrl',
            type: {
              name: 'String'
            }
          },
          certificateStore: {
            required: false,
            serializedName: 'certificateStore',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VaultCertificate;
