/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Capture Virtual Machine parameters.
 *
 */
class VirtualMachineCaptureParameters {
  /**
   * Create a VirtualMachineCaptureParameters.
   * @member {string} vhdPrefix The captured virtual hard disk's name prefix.
   * @member {string} destinationContainerName The destination container name.
   * @member {boolean} overwriteVhds Specifies whether to overwrite the
   * destination virtual hard disk, in case of conflict.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineCaptureParameters
   *
   * @returns {object} metadata of VirtualMachineCaptureParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineCaptureParameters',
      type: {
        name: 'Composite',
        className: 'VirtualMachineCaptureParameters',
        modelProperties: {
          vhdPrefix: {
            required: true,
            serializedName: 'vhdPrefix',
            type: {
              name: 'String'
            }
          },
          destinationContainerName: {
            required: true,
            serializedName: 'destinationContainerName',
            type: {
              name: 'String'
            }
          },
          overwriteVhds: {
            required: true,
            serializedName: 'overwriteVhds',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineCaptureParameters;
