/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The instance view of a virtual machine extension handler.
 *
 */
class VirtualMachineExtensionHandlerInstanceView {
  /**
   * Create a VirtualMachineExtensionHandlerInstanceView.
   * @member {string} [type] Specifies the type of the extension; an example is
   * "CustomScriptExtension".
   * @member {string} [typeHandlerVersion] Specifies the version of the script
   * handler.
   * @member {object} [status] The extension handler status.
   * @member {string} [status.code] The status code.
   * @member {string} [status.level] The level code. Possible values include:
   * 'Info', 'Warning', 'Error'
   * @member {string} [status.displayStatus] The short localizable label for
   * the status.
   * @member {string} [status.message] The detailed status message, including
   * for alerts and error messages.
   * @member {date} [status.time] The time of the status.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineExtensionHandlerInstanceView
   *
   * @returns {object} metadata of VirtualMachineExtensionHandlerInstanceView
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineExtensionHandlerInstanceView',
      type: {
        name: 'Composite',
        className: 'VirtualMachineExtensionHandlerInstanceView',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          typeHandlerVersion: {
            required: false,
            serializedName: 'typeHandlerVersion',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'Composite',
              className: 'InstanceViewStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineExtensionHandlerInstanceView;
