/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The instance view of a virtual machine extension.
 *
 */
class VirtualMachineExtensionInstanceView {
  /**
   * Create a VirtualMachineExtensionInstanceView.
   * @member {string} [name] The virtual machine extension name.
   * @member {string} [type] Specifies the type of the extension; an example is
   * "CustomScriptExtension".
   * @member {string} [typeHandlerVersion] Specifies the version of the script
   * handler.
   * @member {array} [substatuses] The resource status information.
   * @member {array} [statuses] The resource status information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineExtensionInstanceView
   *
   * @returns {object} metadata of VirtualMachineExtensionInstanceView
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineExtensionInstanceView',
      type: {
        name: 'Composite',
        className: 'VirtualMachineExtensionInstanceView',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          typeHandlerVersion: {
            required: false,
            serializedName: 'typeHandlerVersion',
            type: {
              name: 'String'
            }
          },
          substatuses: {
            required: false,
            serializedName: 'substatuses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InstanceViewStatusElementType',
                  type: {
                    name: 'Composite',
                    className: 'InstanceViewStatus'
                  }
              }
            }
          },
          statuses: {
            required: false,
            serializedName: 'statuses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InstanceViewStatusElementType',
                  type: {
                    name: 'Composite',
                    className: 'InstanceViewStatus'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineExtensionInstanceView;
