/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The health status of the VM.
 *
 */
class VirtualMachineHealthStatus {
  /**
   * Create a VirtualMachineHealthStatus.
   * @member {object} [status] The health status information for the VM.
   * @member {string} [status.code] The status code.
   * @member {string} [status.level] The level code. Possible values include:
   * 'Info', 'Warning', 'Error'
   * @member {string} [status.displayStatus] The short localizable label for
   * the status.
   * @member {string} [status.message] The detailed status message, including
   * for alerts and error messages.
   * @member {date} [status.time] The time of the status.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineHealthStatus
   *
   * @returns {object} metadata of VirtualMachineHealthStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineHealthStatus',
      type: {
        name: 'Composite',
        className: 'VirtualMachineHealthStatus',
        modelProperties: {
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Composite',
              className: 'InstanceViewStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineHealthStatus;
