/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Virtual machine image resource information.
 *
 * @extends models['SubResource']
 */
class VirtualMachineImageResource extends models['SubResource'] {
  /**
   * Create a VirtualMachineImageResource.
   * @member {string} name The name of the resource.
   * @member {string} location The supported Azure location of the resource.
   * @member {object} [tags] Specifies the tags that are assigned to the
   * virtual machine. For more information about using tags, see [Using tags to
   * organize your Azure
   * resources](https://docs.microsoft.com/azure/azure-resource-manager/resource-group-using-tags.md).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualMachineImageResource
   *
   * @returns {object} metadata of VirtualMachineImageResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineImageResource',
      type: {
        name: 'Composite',
        className: 'VirtualMachineImageResource',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineImageResource;
