/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The List Virtual Machine operation response.
 */
class VirtualMachineListResult extends Array {
  /**
   * Create a VirtualMachineListResult.
   * @member {string} [nextLink] The URI to fetch the next page of VMs. Call
   * ListNext() with this URI to fetch the next page of Virtual Machines.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualMachineListResult
   *
   * @returns {object} metadata of VirtualMachineListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineListResult',
      type: {
        name: 'Composite',
        className: 'VirtualMachineListResult',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VirtualMachineElementType',
                  type: {
                    name: 'Composite',
                    className: 'VirtualMachine'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineListResult;
