/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Identity for the virtual machine scale set.
 *
 */
class VirtualMachineScaleSetIdentity {
  /**
   * Create a VirtualMachineScaleSetIdentity.
   * @member {string} [principalId] The principal id of virtual machine scale
   * set identity. This property will only be provided for a system assigned
   * identity.
   * @member {string} [tenantId] The tenant id associated with the virtual
   * machine scale set. This property will only be provided for a system
   * assigned identity.
   * @member {string} [type] The type of identity used for the virtual machine
   * scale set. The type 'SystemAssigned, UserAssigned' includes both an
   * implicitly created identity and a set of user assigned identities. The
   * type 'None' will remove any identities from the virtual machine scale set.
   * Possible values include: 'SystemAssigned', 'UserAssigned',
   * 'SystemAssigned, UserAssigned', 'None'
   * @member {object} [userAssignedIdentities] The list of user identities
   * associated with the virtual machine scale set. The user identity
   * dictionary key references will be ARM resource ids in the form:
   * '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetIdentity
   *
   * @returns {object} metadata of VirtualMachineScaleSetIdentity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetIdentity',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetIdentity',
        modelProperties: {
          principalId: {
            required: false,
            readOnly: true,
            serializedName: 'principalId',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            readOnly: true,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'SystemAssigned', 'UserAssigned', 'SystemAssigned, UserAssigned', 'None' ]
            }
          },
          userAssignedIdentities: {
            required: false,
            serializedName: 'userAssignedIdentities',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'VirtualMachineScaleSetIdentityUserAssignedIdentitiesValueElementType',
                  type: {
                    name: 'Composite',
                    className: 'VirtualMachineScaleSetIdentityUserAssignedIdentitiesValue'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetIdentity;
