/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Contains the IP tag associated with the public IP address.
 *
 */
class VirtualMachineScaleSetIpTag {
  /**
   * Create a VirtualMachineScaleSetIpTag.
   * @member {string} [ipTagType] IP tag type. Example: FirstPartyUsage.
   * @member {string} [tag] IP tag associated with the public IP. Example: SQL,
   * Storage etc.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetIpTag
   *
   * @returns {object} metadata of VirtualMachineScaleSetIpTag
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetIpTag',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetIpTag',
        modelProperties: {
          ipTagType: {
            required: false,
            serializedName: 'ipTagType',
            type: {
              name: 'String'
            }
          },
          tag: {
            required: false,
            serializedName: 'tag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetIpTag;
