/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * List of Virtual Machine Scale Set OS Upgrade History operation response.
 */
class VirtualMachineScaleSetListOSUpgradeHistory extends Array {
  /**
   * Create a VirtualMachineScaleSetListOSUpgradeHistory.
   * @member {string} [nextLink] The uri to fetch the next page of OS Upgrade
   * History. Call ListNext() with this to fetch the next page of history of
   * upgrades.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetListOSUpgradeHistory
   *
   * @returns {object} metadata of VirtualMachineScaleSetListOSUpgradeHistory
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetListOSUpgradeHistory',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetListOSUpgradeHistory',
        modelProperties: {
          value: {
            required: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UpgradeOperationHistoricalStatusInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'UpgradeOperationHistoricalStatusInfo'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetListOSUpgradeHistory;
