/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a virtual machine scale set network profile.
 *
 */
class VirtualMachineScaleSetNetworkProfile {
  /**
   * Create a VirtualMachineScaleSetNetworkProfile.
   * @member {object} [healthProbe] A reference to a load balancer probe used
   * to determine the health of an instance in the virtual machine scale set.
   * The reference will be in the form:
   * '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/loadBalancers/{loadBalancerName}/probes/{probeName}'.
   * @member {string} [healthProbe.id] The ARM resource id in the form of
   * /subscriptions/{SubcriptionId}/resourceGroups/{ResourceGroupName}/...
   * @member {array} [networkInterfaceConfigurations] The list of network
   * configurations.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetNetworkProfile
   *
   * @returns {object} metadata of VirtualMachineScaleSetNetworkProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetNetworkProfile',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetNetworkProfile',
        modelProperties: {
          healthProbe: {
            required: false,
            serializedName: 'healthProbe',
            type: {
              name: 'Composite',
              className: 'ApiEntityReference'
            }
          },
          networkInterfaceConfigurations: {
            required: false,
            serializedName: 'networkInterfaceConfigurations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VirtualMachineScaleSetNetworkConfigurationElementType',
                  type: {
                    name: 'Composite',
                    className: 'VirtualMachineScaleSetNetworkConfiguration'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetNetworkProfile;
