/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a virtual machines scale set IP Configuration's PublicIPAddress
 * configuration
 *
 */
class VirtualMachineScaleSetPublicIPAddressConfiguration {
  /**
   * Create a VirtualMachineScaleSetPublicIPAddressConfiguration.
   * @member {string} name The publicIP address configuration name.
   * @member {number} [idleTimeoutInMinutes] The idle timeout of the public IP
   * address.
   * @member {object} [dnsSettings] The dns settings to be applied on the
   * publicIP addresses .
   * @member {string} [dnsSettings.domainNameLabel] The Domain name label.The
   * concatenation of the domain name label and vm index will be the domain
   * name labels of the PublicIPAddress resources that will be created
   * @member {array} [ipTags] The list of IP tags associated with the public IP
   * address.
   * @member {object} [publicIPPrefix] The PublicIPPrefix from which to
   * allocate publicIP addresses.
   * @member {string} [publicIPPrefix.id] Resource Id
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetPublicIPAddressConfiguration
   *
   * @returns {object} metadata of VirtualMachineScaleSetPublicIPAddressConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetPublicIPAddressConfiguration',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetPublicIPAddressConfiguration',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          idleTimeoutInMinutes: {
            required: false,
            serializedName: 'properties.idleTimeoutInMinutes',
            type: {
              name: 'Number'
            }
          },
          dnsSettings: {
            required: false,
            serializedName: 'properties.dnsSettings',
            type: {
              name: 'Composite',
              className: 'VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings'
            }
          },
          ipTags: {
            required: false,
            serializedName: 'properties.ipTags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VirtualMachineScaleSetIpTagElementType',
                  type: {
                    name: 'Composite',
                    className: 'VirtualMachineScaleSetIpTag'
                  }
              }
            }
          },
          publicIPPrefix: {
            required: false,
            serializedName: 'properties.publicIPPrefix',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetPublicIPAddressConfiguration;
