/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a virtual machines scale set IP Configuration's PublicIPAddress
 * configuration
 *
 */
class VirtualMachineScaleSetUpdatePublicIPAddressConfiguration {
  /**
   * Create a VirtualMachineScaleSetUpdatePublicIPAddressConfiguration.
   * @member {string} [name] The publicIP address configuration name.
   * @member {number} [idleTimeoutInMinutes] The idle timeout of the public IP
   * address.
   * @member {object} [dnsSettings] The dns settings to be applied on the
   * publicIP addresses .
   * @member {string} [dnsSettings.domainNameLabel] The Domain name label.The
   * concatenation of the domain name label and vm index will be the domain
   * name labels of the PublicIPAddress resources that will be created
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetUpdatePublicIPAddressConfiguration
   *
   * @returns {object} metadata of VirtualMachineScaleSetUpdatePublicIPAddressConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetUpdatePublicIPAddressConfiguration',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetUpdatePublicIPAddressConfiguration',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          idleTimeoutInMinutes: {
            required: false,
            serializedName: 'properties.idleTimeoutInMinutes',
            type: {
              name: 'Number'
            }
          },
          dnsSettings: {
            required: false,
            serializedName: 'properties.dnsSettings',
            type: {
              name: 'Composite',
              className: 'VirtualMachineScaleSetPublicIPAddressConfigurationDnsSettings'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetUpdatePublicIPAddressConfiguration;
