/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Extensions summary for virtual machines of a virtual machine scale set.
 *
 */
class VirtualMachineScaleSetVMExtensionsSummary {
  /**
   * Create a VirtualMachineScaleSetVMExtensionsSummary.
   * @member {string} [name] The extension name.
   * @member {array} [statusesSummary] The extensions information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineScaleSetVMExtensionsSummary
   *
   * @returns {object} metadata of VirtualMachineScaleSetVMExtensionsSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineScaleSetVMExtensionsSummary',
      type: {
        name: 'Composite',
        className: 'VirtualMachineScaleSetVMExtensionsSummary',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          statusesSummary: {
            required: false,
            readOnly: true,
            serializedName: 'statusesSummary',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VirtualMachineStatusCodeCountElementType',
                  type: {
                    name: 'Composite',
                    className: 'VirtualMachineStatusCodeCount'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineScaleSetVMExtensionsSummary;
