/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The status code and count of the virtual machine scale set instance view
 * status summary.
 *
 */
class VirtualMachineStatusCodeCount {
  /**
   * Create a VirtualMachineStatusCodeCount.
   * @member {string} [code] The instance view status code.
   * @member {number} [count] The number of instances having a particular
   * status code.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineStatusCodeCount
   *
   * @returns {object} metadata of VirtualMachineStatusCodeCount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineStatusCodeCount',
      type: {
        name: 'Composite',
        className: 'VirtualMachineStatusCodeCount',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          count: {
            required: false,
            readOnly: true,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineStatusCodeCount;
